<?php

namespace Teknisa\FIS\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\NewCode;

class Fis00800InventarioFiscalFactory {

  protected $connection;
  private $newCode;


  public function __construct(EntityManager $entityManager, NewCode $newCode) {
    $this->connection = $entityManager->getConnection();
    $this->newCode = $newCode;
  }


  public function retrieveRowsQueryInvCons ($row) {

    $DTINVEFISCAL = $row['DTINVEFISCAL'];
    $CDEMPRESA = $row['CDEMPRESA'];
    $NRORG = $row['NRORG'];
    $result = array();

    foreach($row['CDINSCESTA'] as $CDINSCESTA) {

      $sql = "SELECT
    NVL(SUM(B.QTESTOQDIA),0) AS QTPRODINVFIL,
    NVL(SUM(B.VRESTOQDIA),0) AS VRTOTAINVFIL,
    F.CDINSCESTA,
    F.CDEMPRESA,
    F.CDFILIAL,
    NULL AS CDCLASFISC,
    NVL(A.CDPRODUTO,0) AS CDPRODUTO,
    NVL(A.SGUNIDADE,0) AS SGUNIDADE,
    NVL(A.NMPRODUTO,0) AS DSCLASFISC,
    SUM(NVL(CUSTO_PRODUTO(B.CDFILIAL,A.CDPRODUTO,'3',TO_DATE(:P_DTINVEFISCAL,'DD/MM/YYYY HH24:MI:SS') + 1,SYSDATE),0) * B.QTESTOQDIA) AS VRUNITINVFIL
,
    FC.PARTICIPANTE,
    FC.IDTIPOPART,
    CASE
            WHEN NVL(FC.CDALMOXINFO,'X') <> 'X'
                 AND FC.CDALMOXINFO = B.CDALMOXARIFE
                 AND FC.CDLOCALINFO = B.CDLOCALESTOQ THEN '1'
            WHEN NVL(FC.CDALMOXTERC,'X') <> 'X'
                 AND FC.CDALMOXTERC = B.CDALMOXARIFE
                 AND FC.CDLOCALTERC = B.CDLOCALESTOQ THEN '2'
            WHEN NVL(FC.CDALMOXARIFE,'X') <> 'X'
                 AND FC.CDALMOXARIFE = B.CDALMOXARIFE
                 AND FC.CDLOCALESTOQ = B.CDLOCALESTOQ THEN '2'
            ELSE '0'
        END
    IND_EST
FROM
    FILIAL F
    INNER JOIN ALMOXARIFADO AL ON ( ( F.CDEMPRESA =:P_CDEMPRESA )
                                    AND ( F.CDFILIAL = AL.CDFILIAL ) )
    INNER JOIN LOCALESTOQUE LE ON ( ( AL.CDFILIAL = LE.CDFILIAL )
                                    AND ( AL.CDALMOXARIFE = LE.CDALMOXARIFE ) )
    INNER JOIN POSESTDIA B ON ( ( LE.CDFILIAL = B.CDFILIAL )
                                AND ( LE.CDALMOXARIFE = B.CDALMOXARIFE )
                                AND ( LE.CDLOCALESTOQ = B.CDLOCALESTOQ ) )
    LEFT JOIN (
        SELECT
            A.CDFILIAL,
            A.CDCLIENTE AS PARTICIPANTE,
            A.CDALMOXARIFE,
            A.CDLOCALESTOQ,
            C.NRINSJURCLIE AS NRINSJUR,
            'C' AS IDTIPOPART,
            A.CDALMOXTERCCLI CDALMOXTERC,
            A.CDLOCALTERCCLI CDLOCALTERC,
            A.CDALMOXINFOCLI CDALMOXINFO,
            A.CDLOCALINFOCLI CDLOCALINFO
        FROM
            AGENTETERCECLI A,
            CLIENTE C
        WHERE
            ( A.CDCLIENTE = C.CDCLIENTE )
        UNION
        SELECT
            A.CDFILIAL,
            A.CDFORNECED AS PARTICIPANTE,
            A.CDALMOXARIFE,
            A.CDLOCALESTOQ,
            C.NRINSJURFORN AS NRINSJUR,
            'F' AS IDTIPOPART,
            A.CDALMOXTERCFOR CDALMOXTERC,
            A.CDLOCALTERCFOR CDLOCALTERC,
            A.CDALMOXINFOFOR CDALMOXINFO,
            A.CDLOCALINFOFOR CDLOCALINFO
        FROM
            AGENTETERCEFOR A,
            FORNECEDOR C
        WHERE
            ( A.CDFORNECED = C.CDFORNECED )
    ) FC ON ( ( FC.CDFILIAL = B.CDFILIAL )
              AND (
        (
            ( FC.CDALMOXARIFE = B.CDALMOXARIFE )
            AND ( FC.CDLOCALESTOQ = B.CDLOCALESTOQ )
        )
        OR (
            ( FC.CDALMOXTERC = B.CDALMOXARIFE )
            AND ( FC.CDLOCALTERC = B.CDLOCALESTOQ )
        )
        OR (
            ( FC.CDALMOXINFO = B.CDALMOXARIFE )
            AND ( FC.CDLOCALINFO = B.CDLOCALESTOQ )
        )
    ) )
    INNER JOIN (
        SELECT
            D.CDPRODUTO,
            D.NMPRODUTO,
            D.SGUNIDADE,
            D.CDARVPROD,
            D.CDPRODESTO
        FROM
            PRODUTO D
        WHERE
            ( D.CDARVPROD BETWEEN '0' AND 'z' )
            AND ( D.IDPRODUSOCONS = 'N' )
    ) A ON ( ( B.CDPRODUTO = A.CDPRODUTO )
             AND ( A.CDPRODUTO = A.CDPRODESTO ) )
WHERE
    ( ABS(B.QTESTOQDIA) > 0.00001 )
    AND ( INSTR(F.CDINSCESTA,:P_CDINSCESTA) > 0 )
    AND ( B.DTPOSIESTQ = (
        SELECT
            MAX(P.DTPOSIESTQ)
        FROM
            POSESTDIA P
        WHERE
            ( P.CDFILIAL = B.CDFILIAL )
            AND ( P.CDPRODUTO = B.CDPRODUTO )
            AND ( P.CDALMOXARIFE = B.CDALMOXARIFE )
            AND ( P.CDLOCALESTOQ = B.CDLOCALESTOQ )
            AND ( P.NRLOTEESTQ = B.NRLOTEESTQ )
            AND ( P.NRSUBLOTE = B.NRSUBLOTE )
            AND ( P.DTPOSIESTQ <= TO_DATE(:P_DTINVEFISCAL,'DD/MM/YYYY HH24:MI:SS') + 1 )
    ) )
GROUP BY
    F.CDINSCESTA,
    F.CDEMPRESA,
    F.CDFILIAL,
    A.CDPRODUTO,
    A.SGUNIDADE,
    A.NMPRODUTO,
    FC.PARTICIPANTE,
    FC.IDTIPOPART,
    CASE
            WHEN NVL(FC.CDALMOXINFO,'X') <> 'X'
                 AND FC.CDALMOXINFO = B.CDALMOXARIFE
                 AND FC.CDLOCALINFO = B.CDLOCALESTOQ THEN '1'
            WHEN NVL(FC.CDALMOXTERC,'X') <> 'X'
                 AND FC.CDALMOXTERC = B.CDALMOXARIFE
                 AND FC.CDLOCALTERC = B.CDLOCALESTOQ THEN '2'
            WHEN NVL(FC.CDALMOXARIFE,'X') <> 'X'
                 AND FC.CDALMOXARIFE = B.CDALMOXARIFE
                 AND FC.CDLOCALESTOQ = B.CDLOCALESTOQ THEN '2'
            ELSE '0'
        END";

      $std = $this->connection->prepare($sql);
      $params = array('P_DTINVEFISCAL' => $DTINVEFISCAL,
                      'P_CDEMPRESA' => $CDEMPRESA,
                      'P_CDINSCESTA' => $CDINSCESTA );
      $std->execute($params);

      $fetchedRow = $std->fetchAll();
      //Se tiver resultado, adiciona-o a vetor com os dados necessários
      //para inserção na tabela de inventário fiscal.
      if (!empty($fetchedRow)){
        $result[$CDINSCESTA] = $fetchedRow;
      }

    }

    return $result;

  }

  public function deleteExistingInventarioFiscal($row, $queryResult) {

    $DTINVEFISCAL = $row['DTINVEFISCAL'];
    $CDEMPRESA = $row['CDEMPRESA'];
    $NRORG = $row['NRORG'];

    foreach($queryResult as $CDINSCESTA => $fields) {
      $sql = "DELETE FROM INVENTFISC
		  	      WHERE DTINVEFISCAL = :P_DTINVEFISCAL
		  	      AND CDEMPRESA = :P_CDEMPRESA
		  	      AND INSTR(:P_CDINSCESTA, CDINSCESTA) > 0
		  	      AND NRORG = :P_NRORG";
      $std = $this->connection->prepare($sql);
      $params = array('P_DTINVEFISCAL' => $DTINVEFISCAL,
                      'P_CDEMPRESA' => $CDEMPRESA,
                      'P_CDINSCESTA' => $CDINSCESTA,
                      'P_NRORG' => $NRORG );
      $std->execute($params);
    }

  }

  public function importInventarioFiscalInvCons($row, $resultInvCons) {
    $tableName = 'INVENTFISC';
    $NRORG = $row['NRORG'];
    $CDEMPRESA = $row['CDEMPRESA'];
    $DTINVEFISCAL = $row['DTINVEFISCAL'];


    $sql = "INSERT INTO INVENTFISC
			(NRSEQINVFISC, CDEMPRESA, CDINSCESTA, DTINVEFISCAL, CDCLASFISC, DSDISCRITEM, QTESTINVFISC, CDUNIDINVE,
			  VRUNIINVFISC, VRTOTINVFISC, CDPRODUTO, CDCLIENTE, CDFORNECED, IDPROPRIEDADE, IDORIGDESTINV, CDFILIAL)
			VALUES
          (:NRSEQINVFISC,
          :CDEMPRESA,
          :CDINSCESTA,
          :DTINVEFISCAL,
          :CDCLASFISC,
          :DSDISCRITEM,
          :QTESTINVFISC,
          :CDUNIDINVE,
          :VRUNIINVFISC,
          :VRTOTINVFISC,
          :CDPRODUTO,
          :CDCLIENTE,
          :CDFORNECED,
          :IDPROPRIEDADE,
          :IDORIGDESTINV,
          :CDFILIAL
				  )";

    $std = $this->connection->prepare($sql);

    foreach($resultInvCons as $CDINSCESTA => $arrayInvConsRow) {
        foreach ($arrayInvConsRow as $key => $resultInvConsRow){
            $CDCLASFISC = $resultInvConsRow['CDCLASFISC'];
            $DSDISCRITEM = $resultInvConsRow['DSCLASFISC'];
            $VRTOTINVFISC = $resultInvConsRow['VRTOTAINVFIL'];
            $IDPROPRIEDADE = $resultInvConsRow['IND_EST'];
            $IDORIGDESTINV = $resultInvConsRow['IDTIPOPART'];
            $CDFILIAL = $resultInvConsRow['CDFILIAL'];
            
            $CDFORNECED = $IDORIGDESTINV == 'F' ? $resultInvConsRow['PARTICIPANTE'] : '';
            $CDCLIENTE = $IDORIGDESTINV == 'C' ? $resultInvConsRow['PARTICIPANTE'] : '';
            
            $resultRelacProdDol = $this->queryRelacProdDol($resultInvConsRow['CDPRODUTO']);
            if (!empty($resultRelacProdDol)) {
            $CDPRODUTO = $resultRelacProdDol['CDPRODESTO'];
            $VRUNIINVFISC = $resultInvConsRow['VRUNITINVFIL'] / $resultRelacProdDol['VRFATOCONV'];
            $QTESTINVFISC = $resultInvConsRow['QTPRODINVFIL'] * $resultRelacProdDol['VRFATOCONV'];
            $CDUNIDINVE = $resultRelacProdDol['SGUNIDADE'];
            } else {
            $CDPRODUTO = $resultInvConsRow['CDPRODUTO'];
            $VRUNIINVFISC = $resultInvConsRow['VRUNITINVFIL'];
            $QTESTINVFISC = $resultInvConsRow['QTPRODINVFIL'];
            $CDUNIDINVE = $resultInvConsRow['SGUNIDADE'];
            }
            
            $NRSEQINVFISC = $this->newCode->getCodeByTableName($tableName, $NRORG, 1, 0, true);
            
            $params = array(':NRSEQINVFISC' => $NRSEQINVFISC,
                          ':CDEMPRESA' => $CDEMPRESA,
                          ':CDINSCESTA' => $CDINSCESTA,
                          ':DTINVEFISCAL' => $DTINVEFISCAL,
                          ':CDCLASFISC' => $CDCLASFISC,
                          ':DSDISCRITEM' => $DSDISCRITEM,
                          ':VRTOTINVFISC' => $VRTOTINVFISC,
                          ':CDCLIENTE' => $CDCLIENTE,
                          ':CDFORNECED' => $CDFORNECED,
                          ':CDPRODUTO' => $CDPRODUTO,
                          ':VRUNIINVFISC' => $VRUNIINVFISC,
                          ':QTESTINVFISC' => $QTESTINVFISC,
                          ':CDUNIDINVE' => $CDUNIDINVE,
                          ':IDPROPRIEDADE' => $IDPROPRIEDADE,
                          ':IDORIGDESTINV' => $IDORIGDESTINV,
                          ':CDFILIAL' => $CDFILIAL);
            
            $std->execute($params);
        }
    }

  }

  private function queryRelacProdDol($CDPRODUTO) {

    $sql = "SELECT R.CDPRODARVOL, R.CDPRARVORIG, P.CDPRODESTO,
					   NVL(P.VRFATOCONV,1) AS VRFATOCONV, E.SGUNIDADE
				  FROM RELACPRODOL R, PRODUTO P, PRODUTO E
				 WHERE R.CDPRARVORIG = P.CDPRODUTO
				   AND R.CDPRODARVOL = :P_CDPRODARVOL
				   AND P.CDPRODESTO  = E.CDPRODUTO";
		$std = $this->connection->prepare($sql);
		$params = array(':P_CDPRODARVOL' => $CDPRODUTO);
		$std->execute($params);

		return $std->fetch();

  }



}